
unit thy_ask;

interface

uses
  Windows, ExtCtrls, Controls, ComCtrls, StdCtrls, Classes, Buttons, Forms,
  LanManager;

type
  TfChatReq = class(TForm)
    PB: TProgressBar;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    Label1: TLabel;
    Timer1: TTimer;
    LS1: TLanStorage;
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fChatReq: TfChatReq;

procedure WannaTalk(const aMessage: string);
procedure AbortWait;

implementation

{$R *.DFM}

uses
  SysUtils, Dialogs, thy_main, thy_msgs, thy_lanconsts;

procedure WannaTalk(const aMessage: string);
begin
  with fChatReq do begin
    Label1.Caption := aMessage;
    Timer1.Enabled := True;
    PB.Position    := PB.Max;
    Show;
    Application.BringToFront;
  end;
end;

procedure AbortWait;
begin
  fChatReq.Timer1.Enabled := False;
  fMessages.AddMsg(fMain.CompName, 'PopChat', Format(fChatReq.lS1[sTWAR], [fChatReq.Label1.Caption]));
  fChatReq.Close;
end;

procedure TfChatReq.SpeedButton1Click(Sender: TObject);
begin
  Timer1.Enabled := False;
  //ShowMessage('CU: ' + ChatUser + ' CN: ' + fMain.CompName + ' UN: ' + fMain.UserName + ' CA: ' + sChatAnswerOK);
  //fMain.WP.Send(ChatUser, fMain.CompName, fMain.UserName, sChatAnswerOK);
  _SendMessage(fMain.ChatUser, sChatAnswerOK);
  Close;
end;

procedure TfChatReq.SpeedButton2Click(Sender: TObject);
begin
  Timer1.Enabled := False;
  //fMain.WP.Send(ChatUser, fMain.CompName, fMain.UserName, sChatAnswerNO);
  _SendMessage(fMain.ChatUser, sChatAnswerNO);
  Close;
end;

procedure TfChatReq.Timer1Timer(Sender: TObject);
begin
  PB.Position := PB.Position - 1;
  if (PB.Position < 1) then begin
    Timer1.Enabled := False;
    fMessages.AddMsg(fMain.CompName, 'PopChat', Format(lS1[sIHNH], [Label1.Caption]));
    _SendMessage(fMain.ChatUser, sChatAnswerNO);
    Close;
  end;
end;

end.

