unit thy_favor;

interface

uses
  Windows, Forms, StdCtrls, Controls, Buttons, Classes, LanManager;

type
  TfFavor = class(TForm)
    FavorsList: TListBox;
    NameEdit: TEdit;
    CompEdit: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    AddBtn: TSpeedButton;
    DelBtn: TSpeedButton;
    Label3: TLabel;
    Button1: TButton;
    Button2: TButton;
    LS1: TLanStorage;
    procedure FormShow(Sender: TObject);
    procedure FavorsListClick(Sender: TObject);
    procedure AddBtnClick(Sender: TObject);
    procedure DelBtnClick(Sender: TObject);
    procedure NameEditChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
    fAdded: Boolean;
    fAllowChange: Boolean;
    fValues: tStrings;
  public
    { Public declarations }
    procedure AddComp(CompName, UserName: string);
  end;

var
  fFavor: TfFavor;

implementation

uses
  Thy_main;

const
   NewNameStr = 'Favorite';
   NewCompStr = 'Castle';

{$R *.DFM}

procedure TfFavor.AddComp(CompName, UserName: string);
begin
  FormShow(nil);
  fMain.fFavorites.Add(CompName+'='+NewNameStr);
  FavorsList.Items.Add(NewNameStr);
  FavorsList.ItemIndex := FavorsList.Items.Count-1;
  FavorsListClick(nil);
//  if FavorsList.CanFocus then FavorsList.SetFocus;
  fAdded := True;
  ShowModal;
  fAdded := False;
end;

procedure TfFavor.FormShow(Sender: TObject);
var
  I: Integer;
begin
  if not fAdded then begin
    FavorsList.ItemIndex := -1;
    fMain.InitFavors(fValues);
    NameEdit.Text := '';
    CompEdit.Text := '';
    NameEdit.Enabled := False;
    CompEdit.Enabled := False;
    DelBtn.Enabled := False;
    FavorsList.Items.Clear;
    with fMain.fFavorites do
      for I := 0 to Count-1 do
        FavorsList.Items.Add(Values[Names[I]]);
  end;
end;

procedure TfFavor.FavorsListClick(Sender: TObject);
begin
  with fMain.fFavorites do
    if FavorsList.ItemIndex <> -1 then begin
      NameEdit.Enabled := True;
      CompEdit.Enabled := True;
      DelBtn.Enabled := True;
      FAllowChange := False;
      CompEdit.Text := Names[FavorsList.ItemIndex];
      NameEdit.Text := Values[CompEdit.Text];
      FAllowChange := True;
    end;
end;

procedure TfFavor.AddBtnClick(Sender: TObject);
begin
  fMain.fFavorites.Add(NewCompStr+'='+NewNameStr);
  FavorsList.Items.Add(NewNameStr);
end;

procedure TfFavor.DelBtnClick(Sender: TObject);
begin
  if FavorsList.ItemIndex <> -1 then begin
    fMain.fFavorites.Delete(FavorsList.ItemIndex);
    FavorsList.Items.Delete(FavorsList.ItemIndex);
  end;
end;

procedure TfFavor.NameEditChange(Sender: TObject);
begin
  if FAllowChange and (FavorsList.ItemIndex <> -1) then
  begin
    fMain.fFavorites[FavorsList.ItemIndex] := CompEdit.Text+'='+NameEdit.Text;
    FavorsList.Items[FavorsList.ItemIndex] := NameEdit.Text;
  end;
end;

procedure TfFavor.FormCreate(Sender: TObject);
begin
  fValues := TStringList.Create;
  fAllowChange := True;
  fAdded := False;
end;

procedure TfFavor.FormDestroy(Sender: TObject);
begin
  fValues.Free;
end;

procedure TfFavor.Button1Click(Sender: TObject);
begin
  fMain.SaveFavors(fValues);
  fMain.Favors2Menu(fMain.ChatWith1, fMain.MyOnChatMIClick);
  fMain.Favors2Menu(fMain.MessageTo1, fMain.MyOnMessageMIClick);
  fMain.UpdateMainMenu;
end;

end.
