
unit thy_main;

interface

uses
  Windows, Menus, mdMailSlot, RxTray, ExtCtrls, Classes, Controls, ComCtrls, Forms,
  Messages, Registry, LanManager;

type
  TfMain = class(TForm)
    WP: TmdWinPopup;
    SB: TStatusBar;
    Timer1: TTimer;
    PopupMenu1: TPopupMenu;
    ExitPopChat1: TMenuItem;
    About1: TMenuItem;
    Message1: TMenuItem;
    N2: TMenuItem;
    Archive1: TMenuItem;
    Refresh1: TMenuItem;
    Options1: TMenuItem;
    N1: TMenuItem;
    Chat1: TMenuItem;
    Abort1: TMenuItem;
    RxTray1: TRxTray;
    Showface1: TMenuItem;
    MS1: TmdMailSlot;
    PopupMenu4: TPopupMenu;
    Hello1: TMenuItem;
    Window1: TMenuItem;
    MainMenu1: TMainMenu;
    Abort2: TMenuItem;
    Chatwith1: TMenuItem;
    Messageto1: TMenuItem;
    Options2: TMenuItem;
    Sett1: TMenuItem;
    Messagesarchive1: TMenuItem;
    Exit1: TMenuItem;
    N3: TMenuItem;
    About2: TMenuItem;
    Reload1: TMenuItem;
    N4: TMenuItem;
    N11: TMenuItem;
    Exit2: TMenuItem;
    N5: TMenuItem;
    Favorites1: TMenuItem;
    Favorites2: TMenuItem;
    N6: TMenuItem;
    Whowhere1: TMenuItem;
    Whowhere2: TMenuItem;
    LM1: TLanManager;
    N21: TMenuItem;
    LS1: TLanStorage;
    procedure WPMessage(Sender: TObject; mReciever, mSender,
      Msg: String);
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormDestroy(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Trail1Click(Sender: TObject);
    procedure ExitPopChat1Click(Sender: TObject);
    procedure Show1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Archive1Click(Sender: TObject);
    procedure Refresh1Click(Sender: TObject);
    procedure PopupMenu1Popup(Sender: TObject);
    procedure Abort1Click(Sender: TObject);
    procedure Options1Click(Sender: TObject);
    procedure HideTBClick(Sender: TObject);
    procedure Showface1Click(Sender: TObject);
    procedure AbortTBClick(Sender: TObject);
    procedure MS1MessageAvail(Sender: TObject; aMsg: String);
    procedure PopupMenu4Popup(Sender: TObject);
    procedure RxTray1Click(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Window1Click(Sender: TObject);
    procedure Sett1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Reload1Click(Sender: TObject);
    procedure Messagesarchive1Click(Sender: TObject);
    procedure About2Click(Sender: TObject);
    procedure Abort2Click(Sender: TObject);
    procedure SBMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure N11Click(Sender: TObject);
    procedure Exit2Click(Sender: TObject);
    procedure Favorites1Click(Sender: TObject);
    procedure Whowhere1Click(Sender: TObject);
    procedure Whowhere2Click(Sender: TObject);
    procedure N21Click(Sender: TObject);
    procedure LS1CanChangeComponent(Sender: TObject;
      aComponent: TComponent; var CanChange: Boolean);
    procedure LS1CanScanMenuItem(Sender: TObject; aMenuItem: TComponent;
      var CanScan: Boolean);
  private
    { Private declarations }
    fAwaiting  : Boolean;
    fEndQR     : Integer;
    ThyRegistry: tRegistry;
    InsideTimer: Boolean;
    ScanningUsers: Boolean;
    procedure SetAwaiting(aValue: Boolean);
    procedure ScanUsers(aNR: pNETRESOURCE; DomainIndex: Integer);
    procedure ChatWith(const aUser: string);
    function  CheckName(Sender: tObject): Boolean;
    procedure MessageTo(const aUser: string);
    procedure MyOnHelloClick(Sender: tObject);
    procedure ShowArchive;
    procedure Users2Menu(aMenu: tMenuItem; aHandler: tNotifyEvent);
    procedure ToMonitor(const aClient, aMsg: string);
    procedure StopWait;
    procedure WMQueryEND(var aMessage: tWMQueryEndSession); message WM_QUERYENDSESSION;
  public
    { Public declarations }
    CompName	: string;
    UserName    : string;
    fDomains    : tStrings;
    fFavorites  : tStrings;
    fUsers  	: tStrings;
    fWnds   	: tStrings;
    fNoMonMe	: Boolean;
    ChatUser    : string;
    LastUser    : string;
    procedure RefreshUsers;
    function Alias(Value: string): string;
    property Awaiting: Boolean read fAwaiting write SetAwaiting;
    procedure Favors2Menu(aMenu: tMenuItem; aHandler: tNotifyEvent);
    procedure InitFavors(Values: TStrings);
    procedure MyOnChatMIClick(Sender: tObject); // added to public as needed in thy_favor
    procedure MyOnMessageMIClick(Sender: tObject); // 24.10.97
    function  ReadRegValue(const aName: string): string;
    procedure SaveFavors(Values: TStrings);
    procedure WriteRegValue(const aName, aValue: string);
    procedure AddWaiter(const aUser: string);
    procedure UpdateMainMenu;
  end;

var
  fMain     : TfMain;
  lWaiters  : tStrings;
  Terminated: Boolean;
  isNT      : Boolean;
  StartScan : Boolean;

const
  // note
  // This messages must not be internationalized, or two persons with different languages will not be able to communicate
  sChatRequest    = 'If you see this message via WinPopup, just ignore it!'#13#10'[Message was created by PopChat]';
  sChatAnswerOK   = 'I am Pop$hat itself, so you can talk with me.';
  sChatAnswerNO	  = 'Seems to me, nobody is home. Try later...12345#$#';
  sStartChat      = 'Well, I think we must talk!';
  sTheEndComplete = 'The end complete. This is the end.';
  sWaitNoMore	  = '678 Hey! Do not wait any more. My master aborts chatting 678';

  // this is registry keys
  sAutoReplyEnabled = 'AutoReplyYN';
  sAutoReplyDelay   = 'AutoReplyDelay';
  sAutoReplyMessage = 'AutoReplyMessage';
  sUserFilter       = 'UserNamesFilter';
  sStartScan	    = 'StartScan';
  sSaveYM	    = 'SaveYM';
  sBUList	    = 'BUList';
  sCBLan	    = 'CBLan';	

  // name of
  msPCMonSlot	= 'msPCMonSlot';

procedure _SendMessage(const aUser, aMsg: string);
procedure StopAutoReply(const aUser: string);
function Sure(const aMsg: string): Boolean;

const
  sRegKey         = 'Software\HammerSoft\Projects\PopChat(beta)\';
  s_RegOptionsKey = sRegKey + 'Options';
  sRegFavorKey    = sRegKey + 'Favorites\';

implementation

uses
  Thy_talk, Dialogs, thy_msgs, SysUtils, thy_opts, thy_ask, thy_umsg, thy_about, Graphics, Clipbrd, thy_pic, thy_mon, thy_favor,
  thy_whowhere, thy_lanconsts;

{$R *.DFM}

function TfMain.Alias(Value: string): string;
var
  i: Integer;
begin
  Result := Value;
  for i := 0 to fFavorites.Count-1 do
    if UpperCase(fFavorites.Names[i]) = UpperCase(Value) then
    begin
      Result := fFavorites.Values[fFavorites.Names[i]];
      Break;
    end;
end;

procedure TfMain.WPMessage(Sender: TObject; mReciever, mSender, Msg: String);
var
  i: Integer;
  S: string;
begin
  if (mSender <> '') then begin
    ChatUser    := mSender;
    with fSetup.ListBox1 do
      for i := 0 to Pred(Items.Count) do
	if (Pos(AnsiUpperCase(Items[i]), AnsiUpperCase(mSender)) > 0) then begin
	  if (mSender <> CompName) then _SendMessage(mSender, LS1[sWasNoReply]);
	  Exit;
	end;
    S := fSetup.IsBadUser(mSender, Msg);
    if (S <> '') then begin
      _SendMessage(mSender, S);
      Exit;
    end;
    if (Msg = sChatRequest) then WannaTalk(mReciever+ '@' + Alias(mSender) + lS1[sWTC])
    else
    if (Msg = sChatAnswerOK) then begin
      Awaiting := False;
      _SendMessage(mSender, sStartChat);
      StartTalk(mSender, mReciever);
    end else
    if (Msg = sChatAnswerNO) then begin
      Awaiting := False;
      fMessages.AddMsg(fMain.CompName, 'PopChat', lS1[sYRWR]);
    end else
    if (Msg = sWaitNoMore) then AbortWait else
    if (Msg = sStartChat) then StartTalk(mSender, mReciever) else
    if (Msg = sTheEndComplete) then StopTalk(mSender) else WriteReply(mSender, mReciever, Msg);
  end;
end;

type
  netrArray = array[Byte] of tNETRESOURCE;

procedure TfMain.ScanUsers(aNR: pNETRESOURCE; DomainIndex: Integer);
var
  Z: DWORD;
  W: DWORD;
  i: Integer;
  na: ^netrArray;
  EnumHandle: tHandle;
  lS2: string;
  lT : Integer;
  lNR: tNETRESOURCE;
begin
  New(na);
  lT := -2;
  try
    if Assigned(aNR) then begin
      lS2 := aNR^.lpRemoteName;
      if (aNR^.dwType = RESOURCETYPE_PRINT) then lT := -1
					    else lT := aNR^.dwDisplayType;
      case lT of
	RESOURCEDISPLAYTYPE_SERVER: fUsers.AddObject(Copy(lS2, 3, 64), Pointer(DomainIndex));
	RESOURCEDISPLAYTYPE_DOMAIN: fDomains.Add(lS2);
      end;
    end;
    if (lT = -2) or (lT in [RESOURCEDISPLAYTYPE_DOMAIN, RESOURCEDISPLAYTYPE_NETWORK, RESOURCEDISPLAYTYPE_ROOT]) then
      if (WNetOpenEnum(RESOURCE_GLOBALNET, RESOURCETYPE_ANY, 0, aNR, EnumHandle) = NO_ERROR) then begin
	Application.ProcessMessages;
	Z := -1;
	W := SizeOf(na^);
	WNetEnumResource(EnumHandle, Z, na, W);
	if (Z > 0) then begin
	  for i := 1 to Z do ScanUsers(@na^[Pred(i)], fDomains.Count-1);
	  if (na^[0].dwDisplayType = RESOURCEDISPLAYTYPE_NETWORK) and (na^[0].lpProvider = 'NetWare') then
	    with lNR do begin
	      // also scan microsoft network
	      dwScope := RESOURCE_GLOBALNET;
	      dwType := RESOURCETYPE_ANY;
	      dwDisplayType := RESOURCEDISPLAYTYPE_NETWORK;
	      dwUsage := RESOURCEUSAGE_CONTAINER;
	      lpLocalName := nil;
	      lpRemoteName := nil;
	      lpComment := '';
	      lpProvider := 'Microsoft Network';
	      ScanUsers(@lNR, fDomains.Count-1);
	    end;
	end;
	WNetCloseEnum(EnumHandle);
      end;
  finally
    Dispose(na);
  end;
end;

procedure tfMain.UpdateMainMenu;
begin
  Users2Menu(ChatWith1, MyOnChatMIClick);
  Users2Menu(MessageTo1, MyOnMessageMIClick);
end;

procedure tfMain.RefreshUsers;
var
  Icon: TIcon;
  lS  : string;
  lK  : string;
begin
  ScanningUsers := True;
  lK := SB.Panels[1].Text;
  Icon := TIcon.Create;
  try
    Icon.Assign(RxTray1.Icon);
    RxTray1.Icon.Assign(Application.Icon);
    RxTray1.PopupMenu := nil;
    lS := RxTray1.Hint;
    RxTray1.Hint := lS1[sSCU];
    SB.Panels[1].Text := RxTray1.Hint;
    fDomains.Clear;
    fUsers.Clear;
    ScanUsers(nil, -1);
    if (fUsers.Count < 1) then fUsers.AddObject(CompName, Pointer(-1));
    LastUser := CompName;
    RxTray1.Hint := lS;
    RxTray1.Icon.Assign(Icon);
    UpdateMainMenu;
  finally
    RxTray1.PopupMenu := PopupMenu1;
    SB.Panels[1].Text := lK;
    Icon.Free;
    ScanningUsers := False;
  end;
end;

type
  tNMBSProto = procedure(const servername, msgname, fromname: WideString; var buf; buflen: Integer); stdcall;

{var
  aNMBS: tNMBSProto;}

procedure TfMain.FormCreate(Sender: TObject);
var
  lZ: Integer;
  lB: array[0..MAX_COMPUTERNAME_LENGTH] of Char;
  i: Integer;
  Values: TStrings;
begin
  lZ := GetVersion;
  fEndQR := 1;
  isNT := (lZ and $80000000 = 0);
  fDomains  := tStringList.Create;
  fFavorites:= tStringList.Create;
  fUsers    := tStringList.Create;
  fWnds	    := tStringList.Create;
  fAwaiting := True;
  Awaiting  := False;
  LastUser := '';
  lZ := MAX_COMPUTERNAME_LENGTH + 1;
  Randomize;
  if GetComputerName(lB, lZ) then CompName := lB
			     else CompName := 'Unknown station #' + IntToStr(Random(666666));
//  if GetUserName(lB, lZ) then UserName := lB
//                         else UserName := 'Unknown user';
  SB.Panels[0].Text := CompName;
  for i := 1 to ParamCount do
    if (Pos('NOMONME', AnsiUpperCase(ParamStr(i)))  > 0) then fNoMonMe := True;
{$IFDEF CNT}
  if not isNT then
{$ENDIF}
    try
      WP.Open;
      MS1.Slot := msPCMonSlot;
      MS1.Open;
    except
      if isNT then ShowMessage(lS1[sSSMS])
	      else ShowMessage(lS1[sIWF]);
      Terminated := True;
      Application.Terminate;
      Exit;
    end;
{$IFDEF CNT}
  else begin
    aNMBS := GetProcAddress(LoadLibrary('NETAPI32.DLL'), 'NetMessageBufferSend');
    if not Assigned(aNMBS) then ShowMessage('NETAPI fail. You will not be able to send messages.');
  end;
{$ENDIF}
  ThyRegistry := tRegistry.Create;
  with ThyRegistry do begin
    RootKey := HKEY_LOCAL_MACHINE;
    OpenKey('\System\CurrentControlSet\Control', False);
    UserName := ReadString('Current User');
    if (UserName = '') then UserName := '<Somebody>';
    CloseKey;
    RootKey := HKEY_CURRENT_USER;
    OpenKey(s_RegOptionsKey, True);
    StartScan := ValueExists(sStartScan);
    CloseKey;
    if not StartScan then WriteRegValue(sStartScan, '1');
  end;
  StartScan := (ReadRegValue(sStartScan) = '1');
  Values := TStringList.Create;
  try
    InitFavors(Values);
  finally
    Values.Free;
  end;
  if StartScan then RefreshUsers;
{$IFDEF CNT}
  ChatWith1.Enabled := not isNT;
{$ENDIF}
  UpdateMainMenu;
end;

procedure tfMain.SetAwaiting(aValue: Boolean);
begin
  if (aValue <> fAwaiting) then begin
    fAwaiting := aValue;
    Chat1.Enabled   := not aValue;
    Abort1.Enabled  := aValue;
    ChatWith1.Enabled  := not aValue;
    Abort2.Enabled := aValue;
    if aValue then SB.Panels[1].Text := lS1[sAWR]
	      else SB.Panels[1].Text := lS1[sDN];
  end;
end;

function Sure(const aMsg: string): Boolean;
begin
  Result := (MessageDlg(aMsg, mtConfirmation, mbYesNoCancel, 0) = mrYes);
end;

procedure TfMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  ClearTalks;
  CanClose := (lTalks.Count < 1);
  if not CanClose then ShowMessage(lS1[sPST])
  else
    if (fEndQR = 0) then CanClose := True
		    else CanClose := Sure(lS1[sTWE]);
end;

procedure StopAutoReply(const aUser: string);
var
  lI: Integer;
begin
  lI := lWaiters.IndexOf(aUser);
  if (lI >= 0) then begin
    lWaiters.Objects[lI] := Pointer(-2);
    fMain.SB.Panels[1].Text := fMain.lS1[sFNTD];
  end;
end;

procedure _SendMessage(const aUser, aMsg: string);
{const
  maxBuf  = 1024;}
var
{  buf: array[0..maxBuf] of WideChar;
    W: WideString;
   W2: WideString;}
    S: string;
begin
{$IFDEF CNT}
  if isNT then
    if Assigned(aNMBS) then begin
      S := aMsg;
      if (Length(aMsg) > maxBuf) then begin
	ShowMessage('Message will be truncated!');
	SetLength(S, maxBuf);
      end;
      FillChar(buf, SizeOf(buf), #0);
      StringToWideChar(S, @buf, SizeOf(buf));
      W  := aUser;
      W2 := fMain.CompName;
      aNMBS('', W, W2, buf, Length(aMsg) shl 1);
    end
    else ShowMessage('NO! Sevice not found.')
  else
{$ENDIF}
   //ShowMessage('CU: ' + aUser + ' CN: ' + fMain.CompName + ' UN: ' + fMain.UserName + ' CA: ' + aMsg);
   SetLength(S, Length(aMsg));
   Move(aMsg[1], S[1], Length(aMsg));
   fMain.WP.Send(aUser, fMain.CompName, fMain.UserName, S);
end;

procedure TfMain.FormDestroy(Sender: TObject);
begin
{$IFDEF CNT}
  if not isNT then
{$ENDIF}  
   MS1.Close;
  ThyRegistry.Free;
  fUsers.Free;
  fFavorites.Free;
  fDomains.Free;
  fWnds.Free;
end;

function TfMain.ReadRegValue(const aName: string): string;
begin
  Result := '';
  with ThyRegistry do
    if OpenKey(s_RegOptionsKey, False) then begin
      Result := ReadString(aName);
      CloseKey;
    end;
end;

procedure TfMain.WriteRegValue(const aName, aValue: string);
begin
  with ThyRegistry do
    if OpenKey(s_RegOptionsKey, True) then begin
      WriteString(aName, aValue);
      CloseKey;
    end;
end;

procedure tfMain.AddWaiter(const aUser: string);
var
  lI: Integer;
begin
  if not Assigned(fChat) then Application.CreateForm(tfChat, fChat);
  if not InsideTimer then begin
    lI := lWaiters.IndexOf(aUser);
    if (lI >= 0) then
      if (lWaiters.Objects[lI] = Pointer(-3)) then begin	// recorded!
	// at first, delete the Waiter
	lWaiters.Objects[lI] := Pointer(-4);
	// then send OK message
	_SendMessage(lWaiters[lI], ls1[sIWillSend] + lS1[sStdSign]);
      end
      else
    else lWaiters.AddObject(aUser, Pointer(fSetup.ReplyDelay));
  end;
end;

procedure TfMain.Timer1Timer(Sender: TObject);
var
   i: Integer;
  lT: Integer;
  lU: string;
begin
  InsideTimer := True;
  if Assigned(fSetup) and not Terminated and fSetup.AutoReply and (lWaiters.Count > 0) then begin
    i := 0;
    while (i < lWaiters.Count) do begin
      lT := Integer(lWaiters.Objects[i]);
      lU := lWaiters[i];
      if (lT > 0) then begin
	Dec(lT);
	if (lT <= 0) then begin
	  _SendMessage(lU, fSetup.Memo1.Text + ls1[sStdSign]);
	  lWaiters.Objects[i] := Pointer(-3);
	  //Dec(i);
	  fMain.SB.Panels[1].Text := lS1[sRMF] + lU;
	end
	else begin
	  lWaiters.Objects[i] := Pointer(lT);
	  fMain.SB.Panels[1].Text := Format(lS1[sART], [lU, lT]); 
	end;
      end
      else
	case lT of
	  -2,		// there was a master reply!
	  -4: begin	// message recordered!
	    lWaiters.Delete(i);
	    Dec(i);
	  end;
	end;
      Inc(i);
    end;
  end;
  InsideTimer := False;
end;

procedure TfMain.Trail1Click(Sender: TObject);
begin
  Show;
//  Application.Restore;
end;

procedure tfMain.ChatWith(const aUser: string);
begin
  Awaiting := True;
  ChatUser := aUser;
  StopAutoReply(ChatUser);
  _SendMessage(ChatUser, sChatRequest);
end;

function tfMain.CheckName(Sender: tObject): Boolean;
var
  lS: string;
begin
  Result := True;
  if (LastUser = '<The Other Side>') then begin
    lS := ReadRegValue('LASTOT');
    if (lS = '') then lS := lS1[sENH];
    if InputQuery(lS1[sOS], lS1[sINV], lS) then begin
      LastUser := lS;
      WriteRegValue('LASTOT', lS);
    end
    else begin
      Result := False;
      Exit;
    end
  end;
  if ((Sender as tMenuItem).Hint <> '') then LastUser := (Sender as tMenuItem).Hint;
end;

procedure TfMain.ExitPopChat1Click(Sender: TObject);
begin
  Close;
end;

procedure TfMain.InitFavors(Values: TStrings);
var
  I: Integer;
begin
  fFavorites.Clear;
  with ThyRegistry do begin
    OpenKey(sRegFavorKey, True);
    GetValueNames(Values);
    for I := 0 to Values.Count-1 do
      fFavorites.Add(Values[I] + '=' + ReadString(Values[I]));
    CloseKey;
  end;
end;

procedure TfMain.SaveFavors(Values: TStrings);
var
  I: Integer;
begin
  with ThyRegistry do begin
    OpenKey(sRegFavorKey, True);
    for I := 0 to Values.Count-1 do
      DeleteValue(Values[I]);
    for I := 0 to fFavorites.Count-1 do
      WriteString(fFavorites.Names[I], fFavorites.Values[fFavorites.Names[I]]);
    CloseKey;
  end;
end;

procedure TfMain.Show1Click(Sender: TObject);
begin
  Show;
end;

procedure TfMain.About1Click(Sender: TObject);
begin
  ShowAbout;
end;

procedure TfMain.MessageTo(const aUser: string);
begin
  StopAutoReply(aUser);
  SendMsg2Users(aUser, '');
end;

procedure tfMain.ShowArchive;
begin
  if (lML.Count > 0) then fMessages.Show
		     else ShowMessage(lS1[sAIE]);
end;

procedure TfMain.Archive1Click(Sender: TObject);
begin
  ShowArchive;
end;

procedure TfMain.Refresh1Click(Sender: TObject);
begin
  RefreshUsers;
end;

procedure tfMain.MyOnChatMIClick(Sender: tObject);
begin
  LastUser := (Sender as tMenuItem).Caption;
  if CheckName(Sender) then ChatWith(LastUser);
end;

procedure tfMain.MyOnMessageMIClick(Sender: tObject);
begin
  LastUser := (Sender as tMenuItem).Caption;
  if CheckName(Sender) then MessageTo(LastUser);
end;

procedure TfMain.PopupMenu1Popup(Sender: TObject);
begin
{$IFDEF CNT}
  Chat1.Enabled := not isNT;
{$ENDIF}
  Users2Menu(Chat1,    MyOnChatMIClick);
  Users2Menu(Message1, MyOnMessageMIClick);
end;

procedure TfMain.StopWait;
begin
  _SendMessage(ChatUser, sWaitNoMore);
  Awaiting := False;
end;

procedure TfMain.Abort1Click(Sender: TObject);
begin
  StopWait;
end;

procedure TfMain.Options1Click(Sender: TObject);
begin
  fSetup.ShowModal;
end;

procedure tfMain.Favors2Menu(aMenu: tMenuItem; aHandler: tNotifyEvent);
var
  i, j: Integer;
  lMI: tMenuItem;
  S: string;
begin
  j := 0;
  while (j < aMenu.Count) and (aMenu.Items[j].Caption <> ls1[FavorStr]) do Inc(j);
  if (j >= aMenu.Count) then Exit;
  while (aMenu.Items[j].Count > 0) do aMenu.Items[j].Delete(0);
  for i := 0 to Pred(fFavorites.Count) do begin
    S := fFavorites.Names[I];
    if ((aMenu = ChatWith1) or (aMenu = Chat1)) and (Pos(';', S) <> 0) then
    else
    begin
      lMI := tMenuItem.Create(nil);
      lMI.Caption := fFavorites.Values[fFavorites.Names[I]];
      lMI.Hint := fFavorites.Names[I];
      lMI.OnClick := aHandler;
      aMenu.Items[j].Add(lMI);
    end;  
  end;
  if (fFavorites.Count < 1) then aMenu.Items[j].Enabled := False;
end;

procedure tfMain.Users2Menu(aMenu: tMenuItem; aHandler: tNotifyEvent);
var
  i  : Integer;
  lMI: tMenuItem;
begin
  while (aMenu.Count > 0) do aMenu.Delete(0);
  for i := 0 to Pred(fDomains.Count) do begin
    lMI := tMenuItem.Create(nil);
    lMI.Caption := fDomains[i];
    aMenu.Add(lMI);
  end;
  for i := 0 to Pred(fUsers.Count) do begin
    lMI := tMenuItem.Create(nil);
    lMI.Caption := fUsers[i];
    lMI.OnClick := aHandler;
    if Integer(fUsers.Objects[i]) = -1 then aMenu.Add(lMI)
    else aMenu.Items[Integer(fUsers.Objects[i])].Add(lMI);
  end;
  lMI := tMenuItem.Create(nil);
  lMI.Caption := ls1[FavorStr];
  aMenu.Add(lMI);
  Favors2Menu(aMenu, aHandler);
  lMI := tMenuItem.Create(nil);
  lMI.Caption := '<The Other Side>';
  lMI.OnClick := aHandler;
  aMenu.Add(lMI);
end;

procedure TfMain.HideTBClick(Sender: TObject);
begin
  Hide;
end;

procedure TfMain.Showface1Click(Sender: TObject);
begin
  Show;
end;

procedure TfMain.AbortTBClick(Sender: TObject);
begin
  _SendMessage(ChatUser, sWaitNoMore);
  Awaiting := False;
end;

var
  enWinREsult: string;

function MyETWP(aHandle: hWnd; aParam: lParam): Boolean; stdcall;
var
  lS       : string;
  lWndText : array[0..128] of Char;
begin
  Result := True;
  if (aParam = 1973) then begin
    if (GetWindowText(aHandle, @lWndText, 128) > 0) then lS := lWndText
						    else lS := '<???>';
    if (lS <> '<???>') then enWinREsult := enWinREsult + #13#10'  --+> ' + lS;
  end;
end;

function MyEWP(aHandle: hWnd; aParam: lParam): Boolean; stdcall;
var
  lProcID  : DWord;
  lThreadID: DWord;
  lWndText : array[0..128] of Char;
  lS       : string;
  lI       : Integer;
begin
  if (aParam = 1973) then begin
    if (GetWindowText(aHandle, @lWndText, 128) > 0) then lS := lWndText
						    else lS := '<???>';
    lThreadID := GetWindowThreadProcessId(aHandle, @lProcID);
    lI := fMain.fWnds.IndexOfObject(Pointer(lThreadID));
    if (lI < 0) or (fMain.fWnds[lI] = '<???>') then begin
      if (lI >= 0) then fMain.fWnds.Delete(lI);
      fMain.fWnds.AddObject(lS, Pointer(lThreadID));
    end;
  end;
  Result := True;	// all of them
end;

procedure ScanWindows;
var
  i  : Integer;
  lTh: Integer;
begin
  with fMain.fWnds do begin
    Clear;
    enWinREsult := '';
    EnumWindows(@MyEWP, 1973);
    for i := 0 to Pred(Count) do begin
      enWinREsult := enWinREsult + #13#10 + fMain.fWnds[i];
      lTh := Integer(Objects[i]);
      EnumThreadWindows(lTh, @MyETWP, 1973);
    end;
  end;
end;

const
  cBeforeUser = #12#11#8'UN:';
  cPart1      = #11#8#6'PR1';
  cPartX      = #11#8#6'PRX';
  cPartL      = #11#8#6'PRL';

  maxLen      = 100;

procedure tfMain.ToMonitor(const aClient, aMsg: string);

  procedure Check(aValue: Boolean);
  begin
    if not aValue then ShowMessage('Send error.'); //SendToMailSlot(aClient, msPCMonSlot, 'Error');
  end;

var
  lS: string;
  lM: string;
  lZ: Integer;
//  lC: Integer;
begin
  {lM := '';
  for lZ := 1 to Length(aMsg) do
    case aMsg[lZ] of
      #0:  lM := lM + #1#1;
      #1:  lM := lM + #1#2;
      else lM := lM + aMsg[lZ];
    end;}
  lM := aMsg + cBeforeUser + CompName;
  if (Length(lM) > maxLen) then begin
    lZ := 1;
    lS := Copy(lM, lZ, maxLen);
    //lC := 2;
    Check(SendToMailSlot(aClient, msPCMonSlot, cPart1 + lS));		// first part
    Inc(lZ, maxLen);
    while (Length(lM) - lZ + 1 > maxLen) do begin
      lS := {IntToStr(lC); //}Copy(lM, lZ, maxLen);
      Check(SendToMailSlot(aClient, msPCMonSlot, cPartX + lS));	// next parts
      //Application.ProcessMessages;
      Inc(lZ, maxLen);
//      Inc(lC);
    end;
    lS := Copy(lM, lZ, maxLen);
    Check(SendToMailSlot(aClient, msPCMonSlot, cPartL + lS));		// last part
  end
  else SendToMailSlot(aClient, msPCMonSlot, lM);
end;

var
  LongMsg: string;
  Count  : Integer;

procedure TfMain.MS1MessageAvail(Sender: TObject; aMsg: String);
var
  lZ     : Integer;
  lP     : string;
  lS     : string;
  full   : Boolean;
  lBitmap: Graphics.tBitmap;
  lStream: tStream;
  lM     : string;
begin
  //
  if (aMsg <> '') then begin
    lM := aMsg;
    full := False;
    if (Pos(cPart1, lM) = 1) then LongMsg := Copy(lM, Length(cPart1) + 1, Length(lM)) else
    if (Pos(cPartX, lM) = 1) then begin
      LongMsg := LongMsg + Copy(lM, Length(cPartX) + 1, Length(lM)); {else }
      Inc(Count);
      //Caption := IntToStr(Count);
    end else
    if (Pos(cPartL, lM) = 1) then begin
      lM := LongMsg + Copy(lM, Length(cPartL) + 1, Length(lM));
      full := True;
    end
    else full := True;
    if full and (Count >= 0) then begin
      lZ := Pos(cBeforeUser, lM);
      if (lZ > 1) then begin
	lP := Copy(lM, lZ + Length(cBeforeUser), Length(lM));
	lS := Copy(lM, 2, lZ - 2);
	if (UpCase(lM[1]) <> 'A') then fMon.Memo1.Lines.Add(lP + ' --> ' + lM[1] + ':' + lS);
	case UpCase(lM[1]) of
	  'A': WPMessage(nil, CompName, lP, lS);	// show answer
	  'C': if not fNoMonMe then begin					// scan windows
		case UpCase(lM[2]) of
		  'M': lz := WinExec(@lS[2], SW_MINIMIZE);
		  'S': lz := WinExec(@lS[2], SW_SHOW);
		  'X': lz := WinExec(@lS[2], SW_MAXIMIZE);
		  else lz := WinExec(@lS[1], SW_HIDE);
		end;
		if (lZ > 0) then ToMonitor(lP, 'AOK');
	       //ToMonitor(lP, 'A' + UserName);
	     end;
	  'P': {if (Length(lM) > 16) then begin
	    lZ := 1;
	    aMsg := lM;
	    lM   := '';
	    while (lZ <= Length(aMsg)) do begin
	      case aMsg[lZ] of
		#1: begin
		  case aMsg[lZ + 1] of
		    #1: lM  := lM + #0;
		    #2: lM  := lM + #1;
		  end;
		  Inc(lZ);
		end
		else lM := lM + aMsg[lZ];
	      end;
	      Inc(lZ);
	    end;}
	    case UpCase(lM[2]) of
	      'I': begin				// picture
		lM := Copy(lS, 2, Length(lS));
		lZ := FileOpen(lM, fmOpenRead + fmShareDenyNone);
		if (lZ > 0) then try
		  //lStream.Write(lM[2], Length(lM) - 2{???});
		  //lStream.Seek(0, 0);
		  FileClose(lZ);
		  fPic.Image1.Picture.Bitmap.LoadFromFile(lM);
		  fPic.Show;
		finally
		  //lStream.Free;
		  Application.ProcessMessages;
		  DeleteFile(lM);
		end;
	      end;
	    end;
	  //end;
	  'U': if not fNoMonMe then begin					// scan windows
	    ToMonitor(lP, 'A' + UserName);
	  end;
	  'W': if not fNoMonMe then begin					// scan windows
	    ScanWindows;
	    ToMonitor(lP, 'A' + enWinREsult);
	  end
	  else ToMonitor(lP, 'AMonitoring disabled');
	  'V': ToMonitor(lP, 'A' + 'Version m0.4');	// version
					     //  02 -- W & V
					     //  03 -- S & S1 & S2
					     //  04 -- S & S1 now working via file
	  'S': if not fNoMonMe and (Length(lS) > 7) then begin 	//s\\m\a\1
	    case lM[2] of
	      '1': begin
		Delete(lS, 1, 1);
		keybd_event(VK_SNAPSHOT, 1, 0, 0);
	      end
	      else keybd_event(VK_SNAPSHOT, 0, 0, 0);
	    end;
	    lM := lS;
	    Application.ProcessMessages;
	    lBitmap := tBitmap.Create;
	    lZ := FileCreate(lM);
	    if (lZ > 0) then begin
	      FileClose(lZ);
	      lStream := tFileStream.Create(lM, fmCreate);
	      try
		lBitmap.Assign(Clipboard);
		//Clipboard.Clear;
		lBitmap.SaveToStream(lStream);
		//lStream.Seek(0, 0);
		//fPic.Image1.Picture.Bitmap.LoadFromStream(lStream);
		//fPic.ShowModal;
		//SetLength(lS, lStream.Size + 2);
		lS := 'PI' + lM;
		//lS[1] := 'P';
		//lS[2] := 'i';
		//lStream.Seek(0, 0);
		//lStream.Read(lS[3], lStream.Size);
	      finally
		lStream.Free;
		repeat
		  lZ := FileOpen(lM, fmOpenRead + fmShareDenyNone);
		  if (lZ > 0) then FileClose(lZ);
		  Application.ProcessMessages;
		until (lZ > 0);
		ToMonitor(lP, lS);
		lBitmap.Free;
	      end;
	    end
	    else ToMonitor(lP, 'A' + 'Cannot create this file: ' + lM);
	  end
	  else ToMonitor(lP, 'A' + 'File name too short (or monitoring disabled).');
	  else ToMonitor(lP, 'A' + lM[1] + ': not supported.');
	end;
      end;
    end;
  end;
end;

procedure tfMain.MyOnHelloClick(Sender: tObject);
var
  lS: string;
begin
  lS := 'Hi!';
  if InputQuery(lS1[sCMD], lS1[sEM], lS) then ToMonitor((Sender as tMenuItem).Caption, lS);
end;

procedure TfMain.PopupMenu4Popup(Sender: TObject);
begin
  Users2Menu(Hello1, MyOnHelloClick);
end;

procedure TfMain.RxTray1Click(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if not ScanningUsers then begin
    Show;
    Application.BringToFront;
  end;  
end;

procedure TfMain.Window1Click(Sender: TObject);
begin
  fMon.ShowModal;
end;

procedure TfMain.Sett1Click(Sender: TObject);
begin
  fSetup.ShowModal;
end;

procedure TfMain.Exit1Click(Sender: TObject);
begin
  Hide;
end;

procedure TfMain.Reload1Click(Sender: TObject);
begin
  RefreshUsers;
end;

procedure TfMain.Messagesarchive1Click(Sender: TObject);
begin
  ShowArchive;
end;

procedure TfMain.About2Click(Sender: TObject);
begin
  ShowAbout;
end;

procedure TfMain.Abort2Click(Sender: TObject);
begin
  StopWait;
end;

procedure TfMain.SBMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if (ssShift in Shift) and (ssAlt in  Shift) then SB.PopupMenu := PopupMenu4
					      else SB.PopupMenu := nil;
end;

procedure TfMain.N11Click(Sender: TObject);
begin
  PopupMenu4.Popup(Left+10, Top+10);
end;

procedure TfMain.Exit2Click(Sender: TObject);
begin
  Close;
end;

procedure TfMain.Favorites1Click(Sender: TObject);
begin
  fFavor.ShowModal;
end;

procedure TfMain.WMQueryEND(var aMessage: tWMQueryEndSession);
begin
  fEndQR := aMessage.Source;
  aMessage.Result := Integer(CloseQuery and CallTerminateProcs);
end;

procedure TfMain.Whowhere1Click(Sender: TObject);
begin
  fWhoWhere.Show;
end;

procedure TfMain.Whowhere2Click(Sender: TObject);
begin
  fWhoWhere.Show;
end;

procedure TfMain.N21Click(Sender: TObject);
begin
  LM1.StoreCurrentCaptions;
end;

procedure TfMain.LS1CanChangeComponent(Sender: TObject; aComponent: TComponent; var CanChange: Boolean);
begin
  CanChange := (aComponent <> N11) and
	       (aComponent <> N21) and
	       (aComponent <> SB);
end;

procedure TfMain.LS1CanScanMenuItem(Sender: TObject; aMenuItem: TComponent;
  var CanScan: Boolean);
begin
  CanScan := (aMenuItem <> MESSAGETO1) and
	     (aMenuItem <> CHATWITH1) and
	     (aMenuItem <> CHAT1) and
	     (aMenuItem <> MESSAGE1);
end;

end.

