unit thy_msgs;

interface

uses
  Windows, Controls, Buttons, ExtCtrls, StdCtrls, Classes, ComCtrls, Forms,
  LanManager;

type
  TfMessages = class(TForm)
    TC: TTabControl;
    Memo1: TMemo;
    Panel1: TPanel;
    SpeedButton3: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton1: TSpeedButton;
    SpeedButton4: TSpeedButton;
    LS1: TLanStorage;
    procedure TCChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure Memo1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Memo1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormDestroy(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
  private
    { Private declarations }
    fUsers4Reply: tStrings;
  public
    { Public declarations }
    procedure AddMsg(const aFromComp, aFromUser, aMsg: string);
  end;

var
  fMessages: TfMessages;
  lML      : tStrings;
  lLM	   : tStrings;

implementation

uses
  SysUtils, thy_main, thy_umsg, thy_favor, thy_lanconsts;

{$R *.DFM}

procedure tfMessages.AddMsg;
var
  lI: Integer;
  lS: string;
begin
  lS := '<==== ' + lS1[sRCA] + TimeToStr(Time) + ' ==================>'#13#10 + aMsg;
  lI := TC.Tabs.IndexOf(aFromUser + '@' + fMain.Alias(aFromComp));
  if (lI < 0) then begin
    TC.Tabs.Add(aFromUser+ '@' + fMain.Alias(aFromComp));
    fUsers4Reply.Add(aFromComp);
    lI := TC.Tabs.Count - 1;
    lML.Add(lS);
    lLM.Add('Dummy');
  end
  else lML[lI] := lML[lI] + #13#10 + lS;
  lLM[lI] := aMsg;	// remember last message for reply
  TC.TabIndex := lI;
  Memo1.Lines.Text := lML[lI];
  Show;
  Application.BringToFront;
end;

procedure TfMessages.TCChange(Sender: TObject);
begin
  if (TC.TabIndex >= 0) then Memo1.Lines.Text := lML[TC.TabIndex]
			else Memo1.Lines.Clear;
end;

procedure TfMessages.FormCreate(Sender: TObject);
begin
  fUsers4Reply := tStringList.Create;
  TC.Tabs.Clear;
end;

procedure TfMessages.ToolButton2Click(Sender: TObject);
var
  lI: Integer;
begin
  StopAutoReply(fUsers4Reply[TC.TabIndex]);
  lI := TC.TabIndex;
  lML.Delete(lI);
  TC.Tabs.Delete(lI);
  fUsers4Reply.Delete(lI);
  if (TC.Tabs.Count < 1) then Close
  else begin
    if (lI = TC.Tabs.Count) then Dec(lI);
    TC.TabIndex := lI;
    TCChange(Self);
  end;
end;

procedure TfMessages.SpeedButton1Click(Sender: TObject);
var
  lTI: Integer;
begin
  lTI := TC.TabIndex;
  StopAutoReply(fUsers4Reply[lTI]);
  SendMsg2Users(fUsers4Reply[lTI], lLM[lTI]);
end;

procedure TfMessages.SpeedButton2Click(Sender: TObject);
var
  lI: Integer;
begin
  StopAutoReply(fUsers4Reply[TC.TabIndex]);
  lI := TC.TabIndex;
  lML.Delete(lI);
  TC.Tabs.Delete(lI);
  fUsers4Reply.Delete(lI);
  if (TC.Tabs.Count < 1) then Close
  else begin
    if (lI = TC.Tabs.Count) then Dec(lI);
    TC.TabIndex := lI;
    TCChange(Self);
  end;
end;

procedure TfMessages.SpeedButton3Click(Sender: TObject);
begin
  StopAutoReply(fUsers4Reply[TC.TabIndex]);
  Close;
end;

procedure TfMessages.Memo1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  StopAutoReply(fUsers4Reply[TC.TabIndex]);
end;

procedure TfMessages.Memo1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  StopAutoReply(fUsers4Reply[TC.TabIndex]);
end;

procedure TfMessages.FormDestroy(Sender: TObject);
begin
  fUsers4Reply.Free;
end;

procedure TfMessages.SpeedButton4Click(Sender: TObject);
begin
  fFavor.AddComp(fUsers4Reply[TC.TabIndex], '');
end;

initialization
  lML := tStringList.Create;
  lLM := tStringList.Create;

finalization
  lML.Free;
  lLM.Free;

end.

